
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Something (funny) happened on the way to 5.1.0^H1^H2 &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Trial&amp;Error - Prototyping - Continous Integration" href="trialerror.html" />
    <link rel="prev" title="Yah! A security issue - finally!" href="VSV00001.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="trialerror.html" title="Trial&amp;Error - Prototyping - Continous Integration"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="VSV00001.html" title="Yah! A security issue - finally!"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Something (funny) happened on the way to 5.1.0^H1^H2</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="something-funny-happened-on-the-way-to-5-1-0-h1-h2">
<span id="phk-somethinghappened"></span><h1>Something (funny) happened on the way to 5.1.0^H1^H2<a class="headerlink" href="#something-funny-happened-on-the-way-to-5-1-0-h1-h2" title="Permalink to this headline">¶</a></h1>
<p>Some time back we, or to be perfectly honest, I, decided that in
the future we would do two varnish releases per year, march 15th
and september 15th and damn the torpedoes.</p>
<p>The 5.1.X release was the first real test of this and it went a
little less smooth than I would have preferred, and it is pretty
much all my own fault.</p>
<p>As you may have heard, we’re in the process of <a class="reference external" href="https://ing.dk/blog/murvaerk-196778">building a new house</a> and that obviously takes a
lot of time on my part, most recently we have put up our “old” house
for sale etc. etc.</p>
<p>So I was distracted, and suddenly it was march 15th but come hell
or high water:  We cut the release.</p>
<p>… and almost immediately found that it had a total show-stopper
bug which would cause the worker process to restart too often.</p>
<p>Ok, fix that and roll 5.1.1</p>
<p>… and find another two, not quite as severe but still unacceptable
problems.</p>
<p>Deep breath, fix those, and a lot of HTTP/2 stuff reported by
simon &amp; xcir, who kindly subject that part of the code to some
live traffic …  and roll 5.1.2.</p>
<p>This one will stick I hope.   Next release will be September 15th.</p>
<p>… unless something truly horrible lurks in 5.1.2.</p>
<section id="success-failure-or-meh-strike-out-the-not-applicable">
<h2>Success, Failure or Meh? (strike out the not applicable)<a class="headerlink" href="#success-failure-or-meh-strike-out-the-not-applicable" title="Permalink to this headline">¶</a></h2>
<p>Seen from a release engineering point of view we live a very
sheltered life in the Varnish Project.</p>
<p>Our code base is small, 120 thousand lines of code and we
wrote almost all of it ourselves, which means that we
control the quality standard throughout.</p>
<p>Thanks to our focus on code-quality, we have never had to
rush out a bug/security-fix in the full glare of the combined
scorn of Nanog, Hackernews, Reddit and Metasploit <a class="footnote-reference brackets" href="#f2" id="id1">2</a>.</p>
<p>We also don’t link against any huge “middleware” libraries, I think
the biggest ones are Ncurses and PCRE <a class="footnote-reference brackets" href="#f1" id="id2">1</a>, both of which are
quite stable, and we don’t depend on any obscure single-compiler
languages either.</p>
<p>So while rushing out point releases with short notice is pretty
routine for many other projects, it was a new experience for us,
and it reminded us of a couple of things we had sort of forgotten <a class="footnote-reference brackets" href="#f3" id="id3">3</a>.</p>
<p>I am absolutely certain that if we had not had our “release
by calendar” policy in place, I would probably not have been
willing to sign of on a release until after all the
house-building-moving-finding-where-I-put-the-computer madness
is over late in summer, and then I would probably still insist
on delaying it for a month just to catch my bearings.</p>
<p>That would have held some
<a class="reference external" href="/docs/5.1/whats-new/changes-5.1.html">pretty significant new code</a>
from our users for another half year, for no particular reason.</p>
<p>So yeah, it was pretty embarrasing to have to amend our 5.1 release
twice in two weeks, but it did prove that the “release by calendar”
strategy is right for our project:  It forced us to get our s**t
toggether so users can benefit from the work we do in a timely
fashion.</p>
<p>And thanks to the heroic testing efforts of Simon and Xcir, you may
even be able to use the HTTP/2 support in 5.1.2 as a result.</p>
<p>Next time, by which I mean “September 15th 2017”, we’ll try to do better.</p>
<p>Poul-Henning, 2017-04-11</p>
<p class="rubric">Footnotes</p>
<dl class="footnote brackets">
<dt class="label" id="f1"><span class="brackets"><a class="fn-backref" href="#id2">1</a></span></dt>
<dd><p>Ncurses is just shy of 120 thousand lines of code and
PCRE is 96 thousand lines but that is getting of lightly,
compared to linking against any kind of GUI.</p>
</dd>
<dt class="label" id="f2"><span class="brackets"><a class="fn-backref" href="#id1">2</a></span></dt>
<dd><p>The bugs which caused 5.1.1 and 5.1.2 “merely” resulted
in bad stability, they were not security issues.</p>
</dd>
<dt class="label" id="f3"><span class="brackets"><a class="fn-backref" href="#id3">3</a></span></dt>
<dd><p>Always release from a branch, in case you need to release again.</p>
</dd>
</dl>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Something (funny) happened on the way to 5.1.0^H1^H2</a><ul>
<li><a class="reference internal" href="#success-failure-or-meh-strike-out-the-not-applicable">Success, Failure or Meh? (strike out the not applicable)</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="VSV00001.html"
                        title="previous chapter">Yah!  A security issue - finally!</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="trialerror.html"
                        title="next chapter">Trial&amp;Error - Prototyping - Continous Integration</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/somethinghappened.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="trialerror.html" title="Trial&amp;Error - Prototyping - Continous Integration"
             >next</a> |</li>
        <li class="right" >
          <a href="VSV00001.html" title="Yah! A security issue - finally!"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Something (funny) happened on the way to 5.1.0^H1^H2</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>